Module javafx.base
Package javafx.beans.property

## Class DoublePropertyBase

- java.lang.Object
- - javafx.beans.binding.NumberExpressionBase
  - - javafx.beans.binding.DoubleExpression
    - - javafx.beans.property.ReadOnlyDoubleProperty
      - - javafx.beans.property.DoubleProperty
        - - javafx.beans.property.DoublePropertyBase

- All Implemented Interfaces:
    `NumberExpression`, `Observable`, `Property<Number>`, `ReadOnlyProperty<Number>`, `ObservableDoubleValue`, `ObservableNumberValue`, `ObservableValue<Number>`, `WritableDoubleValue`, `WritableNumberValue`, `WritableValue<Number>`
  Direct Known Subclasses:
    `SimpleDoubleProperty`, `StyleableDoubleProperty`

      public abstract class DoublePropertyBase
      extends DoubleProperty

  The class `DoublePropertyBase` is the base class for a property wrapping a `double` value. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.
  Since:
    JavaFX 2.0
  See Also:
    `DoubleProperty`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DoublePropertyBase()` | The constructor of the `DoublePropertyBase`.
    `DoublePropertyBase​(double initialValue)` | The constructor of the `DoublePropertyBase`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addListener​(InvalidationListener listener)` | Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
    `void` | `addListener​(ChangeListener<? super Number> listener)` | Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
    `void` | `bind​(ObservableValue<? extends Number> rawObservable)` | Create a unidirection binding for this `Property`.
    `protected void` | `fireValueChangedEvent()` | Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`.
    `double` | `get()` | Get the wrapped value.
    `protected void` | `invalidated()` | The method `invalidated()` can be overridden to receive invalidation notifications.
    `boolean` | `isBound()` | Can be used to check, if a `Property` is bound.
    `void` | `removeListener​(InvalidationListener listener)` | Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
    `void` | `removeListener​(ChangeListener<? super Number> listener)` | Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
    `void` | `set​(double newValue)` | Set the wrapped value.
    `String` | `toString()` | Returns a string representation of this `DoublePropertyBase` object.
    `void` | `unbind()` | Remove the unidirectional binding for this `Property`.

    - ### Methods inherited from class javafx.beans.property.DoubleProperty

      `asObject, bindBidirectional, doubleProperty, setValue, unbindBidirectional`

    - ### Methods inherited from class javafx.beans.property.ReadOnlyDoubleProperty

      `readOnlyDoubleProperty`

    - ### Methods inherited from class javafx.beans.binding.DoubleExpression

      `add, add, add, add, add, divide, divide, divide, divide, divide, doubleExpression, doubleExpression, doubleValue, floatValue, getValue, intValue, longValue, multiply, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract, subtract`

    - ### Methods inherited from class javafx.beans.binding.NumberExpressionBase

      `asString, asString, asString, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, numberExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `getValue`

    - ### Methods inherited from interface javafx.beans.property.ReadOnlyProperty

      `getBean, getName`

    - ### Methods inherited from interface javafx.beans.value.WritableValue

      `getValue`

- - ### Constructor Detail

    - #### DoublePropertyBase

          public DoublePropertyBase()

      The constructor of the `DoublePropertyBase`.

    - #### DoublePropertyBase

          public DoublePropertyBase​(double initialValue)

      The constructor of the `DoublePropertyBase`.
      Parameters:
        `initialValue` - the initial value of the wrapped value

  - ### Method Detail

    - #### addListener

          public void addListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

      The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

      Parameters:
        `listener` - The listener to register
      See Also:
        `Observable.removeListener(InvalidationListener)`

    - #### removeListener

          public void removeListener​(InvalidationListener listener)

      Description copied from interface: `Observable`
      Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Parameters:
        `listener` - The listener to remove
      See Also:
        `Observable.addListener(InvalidationListener)`

    - #### addListener

          public void addListener​(ChangeListener<? super Number> listener)

      Description copied from interface: `ObservableValue`
      Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

      The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

      Parameters:
        `listener` - The listener to register
      See Also:
        `ObservableValue.removeListener(ChangeListener)`

    - #### removeListener

          public void removeListener​(ChangeListener<? super Number> listener)

      Description copied from interface: `ObservableValue`
      Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Parameters:
        `listener` - The listener to remove
      See Also:
        `ObservableValue.addListener(ChangeListener)`

    - #### fireValueChangedEvent

          protected void fireValueChangedEvent()

      Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`. This method is called when the value is changed, either manually by calling `set(double)` or in case of a bound property, if the binding becomes invalid.

    - #### invalidated

          protected void invalidated()

      The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

    - #### get

          public double get()

      Get the wrapped value. Unlike `WritableValue.getValue()`, this method returns primitive double. Needs to be identical to `WritableValue.getValue()`.
      Returns:
        The current value

    - #### set

          public void set​(double newValue)

      Set the wrapped value. Unlike `WritableDoubleValue.setValue(java.lang.Number)`, this method uses primitive double.
      Parameters:
        `newValue` - The new value

    - #### isBound

          public boolean isBound()

      Can be used to check, if a `Property` is bound.
      Returns:
        `true` if the `Property` is bound, `false` otherwise
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### bind

          public void bind​(ObservableValue<? extends Number> rawObservable)

      Create a unidirection binding for this `Property`.

      Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

      Parameters:
        `rawObservable` - The observable this `Property` should be bound to.

    - #### unbind

          public void unbind()

      Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### toString

          public String toString()

      Returns a string representation of this `DoublePropertyBase` object.
      Overrides:
        `toString` in class `DoubleProperty`
      Returns:
        a string representation of this `DoublePropertyBase` object.